var app = getApp()
Page({
  data: {
    markers: [],
    polyline: [],
    controls: [],
    hasEmptyGrid: false,
    cur_year: '',
    cur_month: '',
    rili: false,
    startTime: false,
    endTime: false,
    bikeId: '',
    bike_no: '',
    longitude: '',
    latitude: '',
  },
  onLoad: function(options) {
    console.log(options, 'options')
    var that = this;
    this.setNowDate();
    this.setData({
      bikeId: options.id,
      bike_no: options.bike_no
    });
    this.getPosition();
  },
  //获取当前车辆信息
  getPosition() {
    let self = this;
    let data = {
      bike_no: self.data.bike_no
    }
    app.request('bike/position', data, 'GET').then(res => {
      if (res.statusCode == 200) {
        console.log(res, '车辆最后位置')
        if (res.data[0] == 0) {
          wx.showToast({
            title: '暂无车辆最后位置信息~',
            icon: 'none'
          })
          wx.getLocation({
            type: 'gcj02',
            success: function(res) {
              var latitude = res.latitude
              var longitude = res.longitude
              self.setData({
                longitude: longitude,
                latitude: latitude
              })
            },
          })
        } else {
          let position = [];
          position[0] = {
            width: 32,
            height: 32,
            zIndex: 1111,
            iconPath: 'http://resource.weilaibike.com/common/start-location-mark-old.png',
            longitude: res.data[0],
            latitude: res.data[1]
          }
          self.setData({
            markers: position,
            longitude: res.data[0],
            latitude: res.data[1]
          })
        }
      }
    })
  },
  start: function() {
    this.setData({
      rili: true,
      startTime: true,
      polyline: []
    })
  },
  end: function() {
    this.setData({
      rili: true,
      endTime: true
    })
  },
  show: function() {
    var that = this;
    console.log(that.data.start)
    console.log(that.data.end)
    if (that.data.start == undefined || that.data.start == '') {
      wx.showToast({
        title: '开始日期不能为空',
        icon: 'none'
      })
      return;
    } else if (that.data.end == undefined || that.data.end == '') {
      wx.showToast({
        title: '结束日期不能为空',
        icon: 'none'
      })
      return;
    } else if (new Date(that.data.start) > new Date(that.data.end)) {
      wx.showToast({
        title: '开始日期不能大于结束日期',
        icon: 'none'
      })
      return;
    } else {
      let arr = [];
      arr.push();
      arr.push(that.data.end)
      var data = {
        'bike_no': that.data.bike_no,
        'time_between[0]': that.data.start,
        'time_between[1]': that.data.end,
      }
      app.request('bike/bikeLocation', data, 'POST').then(res => {
        console.log(res, '车辆位置')
        if (res.statusCode == 200) {
          if (res.data.length == 0) {
            wx.showToast({
              title: '暂无轨迹',
              icon: 'none'
            })
          } else {
            //用户骑行轨迹
            let arr = []
            let points = res.data.all_locations;
            for(let i=0;i<points.length;i++){
              var obj = {};
              var color = ''
              var borderColor = ''
              if(points[i].role=='no'){  //浅紫
                color = '#d684dd'
                borderColor = "#d684dd"
              }
              if (points[i].role == 'worker') { //红
                color = '#ff6477'
                borderColor = "#ff6477"
              }
              if (points[i].role == 'user') {
                color = '#18D3B8'
                borderColor = "#18D3B8" 
              }
              obj.points = points[i].data;
              obj.width = 4;
              obj.color = color;
              obj.borderWidth = 3;
              obj.borderColor = borderColor;
              that.setData({
                polyline: that.data.polyline.concat(obj)
              })
              var maker = [];
              maker = maker.concat(points[0].data[0]);
              maker = maker.concat(points[points.length - 1].data[0])
              for (var j = 0; j < maker.length; j++) {
                maker[j].width = 32;
                maker[j].height = 32;
                maker[j].zIndex = 1111;
              }
              //在地图上显示两个坐标
              maker[0].iconPath = 'http://resource.weilaibike.com/common/start-location-mark.png'
              maker[1].iconPath = 'http://resource.weilaibike.com/common/end-location-mark.png'
              that.setData({
                markers: maker
              })
            }
            // if (points.length > 0) {
            //     var maker = [];
            //     maker = maker.concat(points[0].data[0]);
            //     maker = maker.concat(points[points.length - 1].data[0])
            //     for (var i = 0; i < maker.length; i++) {
            //       maker[i].width = 32;
            //       maker[i].height = 32;
            //       maker[i].zIndex = 1111;
            //     }
            //     //在地图上显示两个坐标
            //     maker[0].iconPath = '/img/start1.png'
            //     maker[1].iconPath = '/img/end1.png'
            //     that.setData({
            //       markers: maker
            //     })
            //   } else {
            //     wx.getLocation({
            //       type: 'gcj02',
            //       success: function (res) {
            //         var latitude = res.latitude
            //         var longitude = res.longitude
            //         that.setData({
            //           longitude: longitude,
            //           latitude: latitude
            //         })
            //       },
            //     })
            //   }
            // obj.points = points;
            // obj.width = 3;
            // obj.color = "#18D3B8";
            // obj.borderWidth = 2;
            // obj.borderColor = "#18D3B8";
            // for (var i = 0; i < points.length; i++) {
            //   console.log(points[i])
            //   var obj = {};
            //   obj.points = points[i];
            //   obj.width = 3;
            //   obj.color = '#18D3B8';
            //   obj.borderWidth = 2;
            //   obj.borderColor = '#18D3B8';
            // }
            
            console.log(that.data.polyline)
            // console.log(obj)
            // console.log(that.data.polyline)
            // if (points.length > 0) {
            //   var maker = [];
            //   maker = maker.concat(points[0]);
            //   maker = maker.concat(points[points.length - 1])
            //   for (var i = 0; i < maker.length; i++) {
            //     maker[i].width = 32;
            //     maker[i].height = 32;
            //     maker[i].zIndex = 1111;
            //   }
            //   //在地图上显示两个坐标
            //   maker[0].iconPath = '/img/start1.png'
            //   maker[1].iconPath = '/img/end1.png'
            //   that.setData({
            //     markers: maker,
            //     longitude: points[center].longitude,
            //     latitude: points[center].latitude
            //   })
            // } else {
            //   wx.getLocation({
            //     type: 'gcj02',
            //     success: function(res) {
            //       var latitude = res.latitude
            //       var longitude = res.longitude
            //       that.setData({
            //         longitude: longitude,
            //         latitude: latitude
            //       })
            //     },
            //   })
            // }
            //运维人员骑行轨迹
            // let points1 = res.data.worker_location;
            // var obj2 = {};
            // obj2.points = points1;
            // obj2.width = 3;
            // obj2.color = '#ffff00';
            // obj2.borderWidth = 2;
            // obj2.borderColor = '#ffff00';
            // that.setData({
            //   polyline: that.data.polyline.concat(obj2),
            // })
            // if(points1.length>0){
            //   let maker1 = [];
            //   maker1 = maker1.concat(points1[0]);
            //   maker1 = maker1.concat(points1[points1.length - 1])
            //   for (var i = 0; i < maker1.length; i++) {
            //     maker1[i].width = 32;
            //     maker1[i].height = 32;
            //     maker1[i].zIndex = 1111;
            //   }
            //   //在地图上显示两个坐标
            //   maker1[0].iconPath = 'http://resource.weilaibike.com/common/start-location-mark-old.png'
            //   maker1[1].iconPath = 'http://resource.weilaibike.com/common/end-location-mark-old.png'
            //   that.setData({
            //     markers: that.data.markers.concat(maker1),
            //   })
            // }
            // //未骑行轨迹
            // let points2 = res.data.no_locatioin; 
            // var noCen = parseInt(points2.length / 2)
            // var obj3 = {};
            // obj3.points = points2;
            // obj3.width =3;
            // obj3.color = '#ff00ff';
            // obj3.borderWidth = 2;
            // obj3.borderColor = '#ff00ff';
            // that.setData({
            //   polyline: that.data.polyline.concat(obj3),
            // })
            // if (points2.length > 0) {
            //   let maker2 = [];
            //   maker2 = maker2.concat(points2[0]);
            //   maker2 = maker2.concat(points2[points2.length - 1])
            //   for (var i = 0; i < maker2.length; i++) {
            //     maker2[i].width = 32;
            //     maker2[i].height = 32;
            //     maker2[i].zIndex = 1111;
            //   }
            //   //在地图上显示两个坐标
            //   maker2[0].iconPath = 'http://resource.weilaibike.com/common/start-location-mark.png'
            //   maker2[1].iconPath = 'http://resource.weilaibike.com/common/end-location-mark.png'
            //   that.setData({
            //     markers: that.data.markers.concat(maker2),
            //   })
            // }
          }
        }
      })
    }
  },
  hidn: function() {
    this.setData({
      start: '',
      end: '',
      startTime: false,
      endTime: false,
      polyline: [],
      markers: []
    })
  },
  onReady: function() {

  },
  onShow: function() {

  },
  onHide: function() {

  },
  onUnload: function() {

  },
  onPullDownRefresh: function() {

  },
  onReachBottom: function() {

  },
  onShareAppMessage: function() {

  },
  dateSelectAction: function(e) {
    var cur_day = e.currentTarget.dataset.idx;
    this.setData({
      todayIndex: cur_day
    })
    var day = cur_day + 1
    console.log(this.data.cur_year + '-' + this.data.cur_month + '-' + day);
    this.setData({
      rili: false
    })
    if (this.data.startTime == true) {
      this.setData({
        startTime: false,
        start: this.data.cur_year + '-' + this.data.cur_month + '-' + day
      })
    }
    if (this.data.endTime == true) {
      this.setData({
        endTime: false,
        end: this.data.cur_year + '-' + this.data.cur_month + '-' + day
      })
    }
  },
  setNowDate: function() {
    const date = new Date();
    const cur_year = date.getFullYear();
    const cur_month = date.getMonth() + 1;
    const todayIndex = date.getDate() - 1;
    console.log(`日期：${todayIndex}`)
    const weeks_ch = ['日', '一', '二', '三', '四', '五', '六'];
    this.calculateEmptyGrids(cur_year, cur_month);
    this.calculateDays(cur_year, cur_month);
    this.setData({
      cur_year: cur_year,
      cur_month: cur_month,
      weeks_ch,
      todayIndex,
    })
  },

  getThisMonthDays(year, month) {
    return new Date(year, month, 0).getDate();
  },
  getFirstDayOfWeek(year, month) {
    return new Date(Date.UTC(year, month - 1, 1)).getDay();
  },
  calculateEmptyGrids(year, month) {
    const firstDayOfWeek = this.getFirstDayOfWeek(year, month);
    let empytGrids = [];
    if (firstDayOfWeek > 0) {
      for (let i = 0; i < firstDayOfWeek; i++) {
        empytGrids.push(i);
      }
      this.setData({
        hasEmptyGrid: true,
        empytGrids
      });
    } else {
      this.setData({
        hasEmptyGrid: false,
        empytGrids: []
      });
    }
  },
  calculateDays(year, month) {
    let days = [];

    const thisMonthDays = this.getThisMonthDays(year, month);

    for (let i = 1; i <= thisMonthDays; i++) {
      days.push(i);
    }

    this.setData({
      days
    });
  },
  handleCalendar(e) {
    const handle = e.currentTarget.dataset.handle;
    const cur_year = this.data.cur_year;
    const cur_month = this.data.cur_month;
    if (handle === 'prev') {
      let newMonth = cur_month - 1;
      let newYear = cur_year;
      if (newMonth < 1) {
        newYear = cur_year - 1;
        newMonth = 12;
      }

      this.calculateDays(newYear, newMonth);
      this.calculateEmptyGrids(newYear, newMonth);

      this.setData({
        cur_year: newYear,
        cur_month: newMonth
      })

    } else {
      let newMonth = cur_month + 1;
      let newYear = cur_year;
      if (newMonth > 12) {
        newYear = cur_year + 1;
        newMonth = 1;
      }

      this.calculateDays(newYear, newMonth);
      this.calculateEmptyGrids(newYear, newMonth);

      this.setData({
        cur_year: newYear,
        cur_month: newMonth
      })
    }
  }
})