var app = getApp()
Page({
  data: {
    account: '',
    pwd: '',
    checked: true, 
  },
  onLoad: function(options) {
    if (wx.getStorageSync('account') && wx.getStorageSync('pwd')) {
      this.setData({
        account: wx.getStorageSync('account'),
        pwd: wx.getStorageSync('pwd'),
        checked: false
      })
    }
    let token = wx.getStorageSync('token')
    if (token) {
      wx.reLaunch({
        url: '/pages/logs/logs',
      })
    } else {
      wx.switchTab({
        url: '/pages/login/login',
      })
    }
  },
  check() {
    let that = this;
    that.data.checked = !that.data.checked
    if (that.data.checked == true) {
      wx.removeStorageSync('account')
      wx.removeStorageSync('pwd')
    }
    that.setData({
      checked: that.data.checked
    })
  },
  //用户名
  accountInp(e) {
    this.setData({
      account: e.detail.value
    })
  },
  //密码
  pwdInp(e) {
    this.setData({
      pwd: e.detail.value
    })
  },
  //登录
  login() {
    if (!this.data.account) {
      wx.showToast({
        title: '账户名不能为空',
        icon: "none"
      })
    } else if (!this.data.pwd) {
      wx.showToast({
        title: '密码不能为空',
        icon: "none"
      })
    } else {
      let data = {
        account: this.data.account,
        password: this.data.pwd
      }
      app.request('auth/login', data, 'POST').then(res => {
        if (res.statusCode == 201) {
          wx.reLaunch({
            url: '/pages/logs/logs',
          })
          console.log(res, '登录')
          wx.setStorageSync('token', res.data.token)
          wx.setStorageSync('role', res.data.role)
          wx.setStorageSync('avatar', res.data.avatar)
          wx.setStorageSync('username', res.data.username)
          if (this.data.checked == false) {
            wx.setStorageSync('account', this.data.account)
            wx.setStorageSync('pwd', this.data.pwd)
          }
        } else if (res.statusCode == 422) {
          wx.showToast({
            title: '账户名或密码错误',
            icon: 'none'
          })
        }
      })
    }
  },
  onReady: function() {

  },
  onShow: function() {

  },
  onHide: function() {

  },
  onUnload: function() {

  },
  onPullDownRefresh: function() {

  },
  onReachBottom: function() {

  },
  onShareAppMessage: function() {

  }
})