const app = getApp();
Page({
  data: {
    latitude: "24.47951",
    longitude: "118.08948",
    markers: [], //点
    polyline: [], //线
    polygons: [], //区域
    list: [],
    fence: [], //点击地图获取的经纬度
    type: '', //停车区类型
    parkName: '', //停车区名称
    markShow: false, //是否显示停车点名称
    parkId: '', //停车点/禁停区id
    detail: [],
    showPop: false, //是否显示弹窗
    areaList: [], //选择所属大区列表
    typeList: [{ //区域类型选项
      type: 1,
      name: '禁停区'
    }, {
      type: 2,
      name: '停车区'
    }],
    options: '',
    parkNum: 0, //停车上限
    mapclick: false, //是否执行地图点击事件
    areaChecked: true, //弹窗区域的状态
    areaId: '', //区域id
    btnShow: false, //重绘  取消
    pushShow: true
  },
  bindPickerChange: function(e) {
    console.log(e);
    let nowArea = this.data.areaList[e.detail.value].text
    let areaId = this.data.areaList[e.detail.value].areaID
    this.setData({
      areaName: nowArea,
      areaId
    })
  },
  bindPickerChange1: function(e) {
    let nowType = this.data.typeList[e.detail.value].name
    let type = this.data.typeList[e.detail.value].type
    this.setData({
      typeName: nowType,
      type
    })
  },
  //添加还车点、禁停区
  push() {
    this.setData({
      showPop: true,
      parkName: '',
      parkNum: 0,
      areaChecked: true,
      areaName: '',
      typeName: '',
      type: 2,
      markShow: false
    })
  },
  bindKeyInput(e) {
    this.setData({
      parkName: e.detail.value
    })
  },
  //选择区域类型
  choiceType() {
    this.setData({
      showType: !this.data.showType
    })
  },
  // 停车上限
  numInput(e) {
    this.setData({
      parkNum: e.detail.value
    })
  },
  // 改变区域状态
  changeState() {
    this.setData({
      areaChecked: !this.data.areaChecked
    })
  },
  //绘制围栏
  draw() {
    let that = this;
    if (!that.data.areaName) {
      wx.showToast({
        title: '请选择所属大区',
        icon: 'none'
      })
    } else if (!that.data.parkName) {
      wx.showToast({
        title: '停车区域名称不能为空',
        icon: 'none'
      })
    } else if (!that.data.typeName) {
      wx.showToast({
        title: '请选择区域类型',
        icon: 'none'
      })
    } else if (that.data.parkNum === '') {
      wx.showToast({
        title: '请输入停车上限',
        icon: 'none'
      })
    } else {
      let data = {
        name: this.data.parkName
      }
      app.request('parking/UniqueParkingName', data, 'POST').then(res => {
        if (res.statusCode == 200) {
          if (res.data.status == 0) {
            wx.showToast({
              title: '停车区域名称已存在',
              icon: 'none'
            })
          } else {
            that.setData({
              showPop: false,
              mapclick: true,
              pushShow: false
            })
            wx.showToast({
              title: '请点击地图进行绘制',
              icon: 'none'
            })
          }
        }
      })
    }
  },
  //取消
  cancel() {
    this.setData({
      showPop: false,
      pushShow: true
    })
  },
  onLoad(options) {
    let that = this;
    that.getArea();
    wx.getLocation({
      type: 'gcj02',
      success: function(res) {
        let latitude = res.latitude;
        let longitude = res.longitude;
        console.log(latitude, longitude)
        that.setData({
          latitude: latitude,
          longitude: longitude
        })
      },
    })
    app.request('index', '', 'GET').then(res => {
      if (res.statusCode == 200) {
        console.log(res, '区域')

        let options = [];
        res.data.wx_area.map(i => {
          options.push(i.text)
        })
        console.log(res.data.wx_area, 5555)
        this.setData({
          areaList: res.data.wx_area,
          options
        })
      }
    })
  },
  // 获取停车区列表
  getArea() {
    var that = this;
    app.request('getAreas', '', 'GET').then(res => {
      console.log(res)
      let data = [];
      data = data.concat(res.data.parking_area)
      data = data.concat(res.data.no_parking_area);
      if (data.length == 0) {
        wx.showToast({
          title: '无还车点',
          icon: 'none'
        })
      } else {
        var mark = [],
          arr = [];
        for (var i = 0; i < data.length; i++) {
          arr = arr.concat(data[i])
        }
        for (var i = 0; i < arr.length; i++) {
          let iconPath = ''
          let color = '';
          let bgColor = '';
          if (arr[i].type == 1) { //禁停区
            color = '#FF0000';
            bgColor = "#FF000022"
          }
          if (arr[i].type == 2) { //停车区
            color = '#18D3B8';
            bgColor = "#18D3B822"
          }
          arr[i].points = arr[i].parking_fence_wx;
          arr[i].strokeWidth = 4;
          arr[i].strokeColor = color;
          arr[i].fillColor = bgColor;
          arr[i].zIndex = i;
          arr[i].iconPath
        }
        for (var i = 0; i < data.length; i++) {
          mark = mark.concat(data[i].parking_centre_wx)
        }
        console.log(mark)
        for (var i = 0; i < mark.length; i++) {
          let iconPath = ''
          mark[i].zIndex = i;
          mark[i].id = i;
          mark[i].name1 = data[i].name;
          mark[i].parkId = data[i].id;
          mark[i].status = data[i].status;
          mark[i].type = data[i].type;
          if (mark[i].type == 1) { //禁停区
            iconPath = 'http://resource.weilaibike.com/redStop.png'
          }
          if (mark[i].type == 2) { //停车区
            iconPath = "http://resource.weilaibike.com/stop1.png"
          }
          mark[i].width = 24;
          mark[i].height = 28;
          mark[i].iconPath = iconPath;
        }
        that.setData({
          polygons: arr,
          markers: mark
        })
        // console.log(that.data.markers)
      }
      var redding = res.data.ridding_area;
      var ridding = {}
      ridding.points = redding[0].area_fence_wx;
      ridding.strokeWidth = 4;
      ridding.strokeColor = '#0000FF';
      ridding.zIndex = 999;
      ridding.fillColor = '#0000FF10';
      // console.log(ridding)
      that.setData({
        polygons: that.data.polygons.concat(ridding)
      })
      var ridding1 = {}
      ridding1.points = redding[1].area_fence_wx;
      ridding1.strokeWidth = 4;
      ridding1.strokeColor = '#0000FF';
      ridding1.zIndex = 999;
      ridding1.fillColor = '#0000FF10';
      that.setData({
        polygons: that.data.polygons.concat(ridding1)
      })
    })
  },
  markertap(e) {
    console.log(e);
    let that = this
    var markers = e.currentTarget.dataset.markers;
    var stop_area = this.data.polygons;
    var arr = []
    that.setData({
      detail: []
    })
    for (var i = 0; i < markers.length; i++) {
      if (markers[i].id == e.markerId && markers[i].type == 2) { //停车区
        markers[i].iconPath = '/img/p.png'
        arr = markers[i];
        that.setData({
          parkName: markers[i].name1,
          markShow: true,
          parkId: markers[i].parkId,
          detail: arr
        })
        markers[i] = arr
      } else {
        if (markers[i].type == 2) {
          markers[i].iconPath = 'http://resource.weilaibike.com/stop1.png';
        }
      }
      if (markers[i].id == e.markerId && markers[i].type == 1) { //禁停区
        markers[i].iconPath = 'http://resource.weilaibike.com/xiaobanma_yunwei/noParking.png'
        arr = markers[i];
        that.setData({
          parkName: markers[i].name1,
          markShow: true,
          parkId: markers[i].parkId,
          detail: arr
        })
        markers[i] = arr
      } else {
        if (markers[i].type == 1) {
          markers[i].iconPath = 'http://resource.weilaibike.com/redStop.png';
        }
      }
    }
    that.setData({
      markers: markers
    })
    console.log(that.data.markers)
    console.log(that.data.detail)
  },
  remove() {
    var that = this;
    wx.showModal({
      title: '提示',
      content: '确定删除该还区域吗？',
      success: function(res) {
        if (res.confirm) {
          app.request('parking/' + that.data.parkId, '', 'DELETE').then(res => {
            if (res.statusCode == 204) {
              wx.showToast({
                title: '删除成功',
                icon: 'none',
                duration: 2000,
              })
              var markers = that.data.markers;
              var polygons = that.data.polygons;
              console.log(markers)
              console.log(polygons)
              for (var i = 0; i < markers.length; i++) {
                if (that.data.parkId == markers[i].parkId) {
                  console.log(i)
                  markers.splice(i, 1)
                  polygons.splice(i, 1)
                  that.setData({
                    markers,
                    polygons,
                    markShow: false,
                    list: []
                  })
                }
              }
            }
          })
        }
      }
    })

  },
  switchCon: function() {
    var that = this;
    var detail = that.data.detail;
    var markers = that.data.markers;
    if (detail.status == 1) {
      detail.status = 0
      console.log(detail.status)
    } else {
      detail.status = 1
      console.log(detail.status)
    }
    for (var i = 0; i < markers.length; i++) {
      if (detail.zIndex == markers[i].zIndex) {
        console.log(detail.zIndex)
        markers[detail.zIndex] = detail
      }
    }
    console.log(detail)
    console.log(markers)
    that.setData({
      detail,
      markers
    })
    let data = {
      status: detail.status,
      id: that.data.parkId
    }
    app.request('parking/status', data, 'POST').then(res => {
      if (res.statusCode == 200) {
        wx.showToast({
          title: '修改成功',
          icon: 'none'
        })

      }
    })
  },
  //重绘
  again() {
    this.getArea();
    this.setData({
      polygons: [],
      markers: [],
      polyline: [],
      list: [],
      btnShow: false
    })
  },
  // 点击地图事件
  mapclick(e) {
    let that = this;
    let arr = that.data.list;
    arr.push(e.detail)
    let iconPath = '';
    let color = '';
    let bgColor = '';
    that.setData({
      markShow: false
    })
    if (!that.data.mapclick) return;
    if (that.data.type == 1) { //禁停区
      iconPath = "http://resource.weilaibike.com/redStop.png";
      color = "#FF0000";
      bgColor = "#FF000022";
    } else if (that.data.type == 2) { //停车区
      iconPath = "http://resource.weilaibike.com/stop1.png";
      color = "#18D5B9";
      bgColor = "#18D5B922"
    }
    if (arr.length == 1) {
      let dot = {};
      dot.id = 0;
      dot.latitude = arr[0].latitude;
      dot.longitude = arr[0].longitude;
      dot.iconPath = iconPath
      dot.width = 28;
      dot.height = 28;
      console.log(dot)
      let dotArr = [];
      dotArr.push(dot)
      that.setData({
        markers: dotArr
      })
    }

    if (arr.length >= 2) {
      let line = {};
      line.points = arr
      line.width = 4;
      line.color = color;
      line.borderWidth = 3;
      line.borderColor = color;
      let lineArr = [];
      lineArr.push(line)
      that.setData({
        polyline: lineArr,
        markers: ''
      })
    }
    if (arr.length >= 3) {
      let area = {};
      that.setData({
        fence: arr,
        btnShow: true
      })
      console.log(arr)
      area.points = arr;
      area.fillColor = bgColor;
      area.strokeColor = color;
      area.strokeWidth = 4;
      area.zIndex = 1;
      let areaArr = []
      areaArr.push(area)
      that.setData({
        polygons: that.data.polygons.concat(areaArr),
        polyline: ''
      })
    }
  },
  cancelBtn() {
    this.setData({
      mapclick: false,
      markers: [],
      polyline: [],
      pushShow: true
    })
    this.getArea();
  },
  //完成
  finish() {
    let that = this;
    console.log(that.data.areaChecked)
    let state = JSON.parse(that.data.areaChecked);
    let parking_fence = []
    that.data.fence.map(i => {
      parking_fence.push({
        lat: i.latitude,
        lng: i.longitude
      })
    })
    if (state) {
      state = 1
    } else {
      state = 0
    }
    console.log(state)
    let data = {
      parking_fence: JSON.stringify(parking_fence),
      area_id: that.data.areaId,
      max_number: that.data.parkNum,
      name: that.data.parkName,
      status: state,
      type: that.data.type,
    }
    app.request('parking', data, 'POST').then(res => {
      if (res.statusCode == 201) {
        console.log(that.data.type, 555)
        console.log(res);
        wx.showToast({
          title: '添加成功',
          icon: 'none',
          duration: 3000,
          success: function() {
            that.getArea()
            that.setData({
              mapclick: false,
              list: [],
              pushShow: true,
            })
          }
        })
      }
    })
  },
})